'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var _require = require('child_process'),
    exec = _require.exec,
    spawn = _require.spawn;

var os = require('os');
var path = require('path');
var fs = require('fs');
var yaml = require('js-yaml');
var conf = {};

try {
  conf = require('../conf');
} catch (_) {}

try {
  var doc = yaml.safeLoad(fs.readFileSync('/etc/eleme/env.yaml', 'utf8'));
  var statsd_url = doc.statsd_url;
  if (statsd_url) {
    var arr = statsd_url.split('//');
    if (arr.length) {
      statsd_url = arr.pop();
    }
    conf = { 'STATSD_URL': statsd_url };
  }
} catch (_) {}

process.on('exit', _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
  return _regenerator2.default.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          console.log('exit');
          _context.next = 3;
          return killProc('mongo-dal');

        case 3:
          process.exit(0);

        case 4:
        case 'end':
          return _context.stop();
      }
    }
  }, _callee, undefined);
})));

process.on('SIGINT', _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
  return _regenerator2.default.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          console.log('exit SIGINT');
          _context2.next = 3;
          return killProc('mongo-dal');

        case 3:
          process.exit(0);

        case 4:
        case 'end':
          return _context2.stop();
      }
    }
  }, _callee2, undefined);
})));

process.on('SIGTERM', _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
  return _regenerator2.default.wrap(function _callee3$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          console.log('exit SIGTERM');
          _context3.next = 3;
          return killProc('mongo-dal');

        case 3:
          process.exit(0);

        case 4:
        case 'end':
          return _context3.stop();
      }
    }
  }, _callee3, undefined);
})));

module.exports = function () {
  var _ref4 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee4(opt) {
    var _opt, id, _opt$output, output, _opt$debug, debug, port, _opt$daemon, daemon, platform, procCmd;

    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            opt = opt || {};
            _opt = opt, id = _opt.id, _opt$output = _opt.output, output = _opt$output === undefined ? 'mongo-dal.log' : _opt$output, _opt$debug = _opt.debug, debug = _opt$debug === undefined ? false : _opt$debug, port = _opt.port, _opt$daemon = _opt.daemon, daemon = _opt$daemon === undefined ? false : _opt$daemon;
            platform = os.platform();
            procCmd = '';


            if (platform === 'linux' || platform === 'darwin') {
              procCmd = path.resolve(__dirname, `../bin/mongo-dal-${platform}`);
            }

            if (procCmd.length) {
              _context4.next = 7;
              break;
            }

            throw new Error(`not support platform: ${platform}!`);

          case 7:
            _context4.next = 9;
            return killProc(`mongo-dal`);

          case 9:
            _context4.next = 11;
            return new Promise(function (resolve, reject) {
              function initResolveCb() {
                resolve();
                process.removeListener('SIGURG', initResolveCb);
              };
              process.on('SIGURG', initResolveCb);

              var args = ['-id', id];

              if (debug || platform === 'darwin') {
                args.push('-d');
              }

              args.push('-o', output);

              if (port != undefined) {
                port = port || 30017;
                args.push('-p', port);
              }

              var opts = undefined;
              if (daemon) {
                args.push('-D');
                opts = { detached: true };
              }

              spawn(procCmd, args, opts);
            });

          case 11:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, undefined);
  }));

  return function (_x) {
    return _ref4.apply(this, arguments);
  };
}();

function killProc(name) {
  return new Promise(function (resolve, reject) {
    exec(`pgrep ${name}`, function (err, stdout, stderr) {
      if (err) {
        return resolve();
      }
      var pidsArg = stdout.replace(/\s/, ' ');

      exec(`kill ${pidsArg}`, function (err, stdout, stderr) {
        resolve(stdout);
      });
    });
  });
}

function _getEnv(opt) {
  var env = process.env.NODE_ENV || opt.env;

  switch (env) {
    case 'alpha':
    case 'alta':
    case 'altb':
    case 'prod':
      return env;
    case 'production':
      return 'prod';
    default:
      return 'alpha';
  }
}